## org.sonatype.plugins.munge
Class Munge

    java.lang.Object
      org.sonatype.plugins.munge.Munge

    public class Munge

extends java.lang.Object

Munge: a purposely-simple Java preprocessor. It only supports conditional inclusion of source based on defined strings of the form "if[tag]", "if_not[tag]", "else[tag], and "end[tag]". Unlike traditional preprocessors, comments and formatting are all preserved for the included lines. This is on purpose, as the output of Munge will be distributed as human-readable source code.

To avoid creating a separate Java dialect, the conditional tags are contained in Java comments. This allows one build to compile the source files without pre-processing, to facilitate faster incremental development. Other builds from the same source have their code contained within that comment. The format of the tags is a little verbose, so that the tags won't accidentally be used by other comment readers such as javadoc. Munge tags must be in C-style comments; C++-style comments may be used to comment code within a comment.

To demonstrate this, our sample source has 1.1 and 1.2-specific code, with 1.1 as the default build:

         public void setSystemProperty(String key, String value) {
             /*if[JDK1.1]*/
             Properties props = System.getProperties();
             props.setProperty(key, value);
             System.setProperties(props);
             /*end[JDK1.1]*/

             /*if[JDK1.2]
             // Use the new System method.
             System.setProperty(key, value);
               end[JDK1.2]*/
         }

When the above code is directly compiled, the code bracketed by the JDK1.1 tags will be used. If the file is run through Munge with the JDK1.2 tag defined, the second code block will used instead. This code can also be written as:

         public void setSystemProperty(String key, String value) {
             /*if[JDK1.2]
             // Use the new System method.
             System.setProperty(key, value);
               else[JDK1.2]*/

             Properties props = System.getProperties();
             props.setProperty(key, value);
             System.setProperties(props);
             /*end[JDK1.2]*/
         }

Munge also performs text substitution; the Swing build uses this to convert its package references from `javax.swing` to `java.awt.swing`, for example. This substitution is has no knowledge of Java syntax, so only use it to convert strings which are unambiguous. Substitutions are made in the same order as the arguments are specified, so the first substitution is made over the whole file before the second one, and so on.

Munge's command line takes one of the following forms:

        java Munge [-D<symbol> ...] [-s <old>=<new> ...] [<in file>] [<out file>]
        java Munge [-D<symbol> ...] [-s <old>=<new> ...] <file> ... <directory>

In the first form, if no output file is given, System.out is used. If neither input nor output file are given, System.in and System.out are used. Munge can also take an `@<cmdfile>` argument. If one is specified then the given file is read for additional command line arguments.

Like any preprocessor, developers must be careful not to abuse its capabilities so that their code becomes unreadable. Please use it as little as possible.

Author:
  jessewilson@google.com (Jesse Wilson)

Constructor Summary
`Munge(java.lang.String inName, java.lang.String outName)`

Method Summary
`void` `close()`
`void` `error(java.lang.String text)`
`boolean` `hasErrors()`
`static void` `main(java.lang.String[] args)` Munge's main entry point.
`void` `printErrorCount()`
`void` `process()`
`static void` `usage()` Report how this utility is used and exit.
`static void` `usage(java.lang.String msg)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### Munge

    public Munge(java.lang.String inName,
                 java.lang.String outName)

Method Detail

### error

    public void error(java.lang.String text)

### printErrorCount

    public void printErrorCount()

### hasErrors

    public boolean hasErrors()

### close

    public void close()
               throws java.io.IOException

  Throws:
    `java.io.IOException`

### process

    public void process()
                 throws java.io.IOException

  Throws:
    `java.io.IOException`

### usage

    public static void usage()

  Report how this utility is used and exit.

### usage

    public static void usage(java.lang.String msg)

### main

    public static void main(java.lang.String[] args)

  Munge's main entry point.

Copyright © 2011. All Rights Reserved.